فهرست منبع

桂阳推送数据接口

zhoujiangyuan 4 سال پیش
والد
کامیت
c1612dbea0
23فایلهای تغییر یافته به همراه1296 افزوده شده و 0 حذف شده
  1. 33 0
      gydatasync/.gitignore
  2. 118 0
      gydatasync/.mvn/wrapper/MavenWrapperDownloader.java
  3. BIN
      gydatasync/.mvn/wrapper/maven-wrapper.jar
  4. 2 0
      gydatasync/.mvn/wrapper/maven-wrapper.properties
  5. 78 0
      gydatasync/log.log
  6. 310 0
      gydatasync/mvnw
  7. 182 0
      gydatasync/mvnw.cmd
  8. 85 0
      gydatasync/pom.xml
  9. 24 0
      gydatasync/src/main/java/com/huaxu/gydatasync/GydatasyncApplication.java
  10. 19 0
      gydatasync/src/main/java/com/huaxu/gydatasync/config/FirstDataBaseProperties.java
  11. 79 0
      gydatasync/src/main/java/com/huaxu/gydatasync/config/FirstDataSourceConfig.java
  12. 19 0
      gydatasync/src/main/java/com/huaxu/gydatasync/config/SecondDataBaseProperties.java
  13. 73 0
      gydatasync/src/main/java/com/huaxu/gydatasync/config/SecondDataSourceConfig.java
  14. 22 0
      gydatasync/src/main/java/com/huaxu/gydatasync/dao/mssql/SaveMeterDataDao.java
  15. 17 0
      gydatasync/src/main/java/com/huaxu/gydatasync/dao/mysql/ReadMeterDao.java
  16. 40 0
      gydatasync/src/main/java/com/huaxu/gydatasync/entity/MeterReadData.java
  17. 68 0
      gydatasync/src/main/java/com/huaxu/gydatasync/service/ReadMeter.java
  18. 21 0
      gydatasync/src/main/resources/application-dev.properties
  19. 11 0
      gydatasync/src/main/resources/application-prd.properties
  20. 4 0
      gydatasync/src/main/resources/application.properties
  21. 48 0
      gydatasync/src/main/resources/mappers/mssql/SaveMeterDataMapper.xml
  22. 20 0
      gydatasync/src/main/resources/mappers/mysql/ReadMeterMapper.xml
  23. 23 0
      gydatasync/src/test/java/com/huaxu/gydatasync/GydatasyncApplicationTests.java

+ 33 - 0
gydatasync/.gitignore

@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/

+ 118 - 0
gydatasync/.mvn/wrapper/MavenWrapperDownloader.java

@@ -0,0 +1,118 @@
+/*
+ * Copyright 2007-present the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      https://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+import java.net.*;
+import java.io.*;
+import java.nio.channels.*;
+import java.util.Properties;
+
+public class MavenWrapperDownloader {
+
+    private static final String WRAPPER_VERSION = "0.5.6";
+    /**
+     * Default URL to download the maven-wrapper.jar from, if no 'downloadUrl' is provided.
+     */
+    private static final String DEFAULT_DOWNLOAD_URL = "https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/"
+            + WRAPPER_VERSION + "/maven-wrapper-" + WRAPPER_VERSION + ".jar";
+
+    /**
+     * Path to the maven-wrapper.properties file, which might contain a downloadUrl property to
+     * use instead of the default one.
+     */
+    private static final String MAVEN_WRAPPER_PROPERTIES_PATH =
+            ".mvn/wrapper/maven-wrapper.properties";
+
+    /**
+     * Path where the maven-wrapper.jar will be saved to.
+     */
+    private static final String MAVEN_WRAPPER_JAR_PATH =
+            ".mvn/wrapper/maven-wrapper.jar";
+
+    /**
+     * Name of the property which should be used to override the default download url for the wrapper.
+     */
+    private static final String PROPERTY_NAME_WRAPPER_URL = "wrapperUrl";
+
+    public static void main(String args[]) {
+        System.out.println("- Downloader started");
+        File baseDirectory = new File(args[0]);
+        System.out.println("- Using base directory: " + baseDirectory.getAbsolutePath());
+
+        // If the maven-wrapper.properties exists, read it and check if it contains a custom
+        // wrapperUrl parameter.
+        File mavenWrapperPropertyFile = new File(baseDirectory, MAVEN_WRAPPER_PROPERTIES_PATH);
+        String url = DEFAULT_DOWNLOAD_URL;
+        if (mavenWrapperPropertyFile.exists()) {
+            FileInputStream mavenWrapperPropertyFileInputStream = null;
+            try {
+                mavenWrapperPropertyFileInputStream = new FileInputStream(mavenWrapperPropertyFile);
+                Properties mavenWrapperProperties = new Properties();
+                mavenWrapperProperties.load(mavenWrapperPropertyFileInputStream);
+                url = mavenWrapperProperties.getProperty(PROPERTY_NAME_WRAPPER_URL, url);
+            } catch (IOException e) {
+                System.out.println("- ERROR loading '" + MAVEN_WRAPPER_PROPERTIES_PATH + "'");
+            } finally {
+                try {
+                    if (mavenWrapperPropertyFileInputStream != null) {
+                        mavenWrapperPropertyFileInputStream.close();
+                    }
+                } catch (IOException e) {
+                    // Ignore ...
+                }
+            }
+        }
+        System.out.println("- Downloading from: " + url);
+
+        File outputFile = new File(baseDirectory.getAbsolutePath(), MAVEN_WRAPPER_JAR_PATH);
+        if (!outputFile.getParentFile().exists()) {
+            if (!outputFile.getParentFile().mkdirs()) {
+                System.out.println(
+                        "- ERROR creating output directory '" + outputFile.getParentFile().getAbsolutePath() + "'");
+            }
+        }
+        System.out.println("- Downloading to: " + outputFile.getAbsolutePath());
+        try {
+            downloadFileFromURL(url, outputFile);
+            System.out.println("Done");
+            System.exit(0);
+        } catch (Throwable e) {
+            System.out.println("- Error downloading");
+            e.printStackTrace();
+            System.exit(1);
+        }
+    }
+
+    private static void downloadFileFromURL(String urlString, File destination) throws Exception {
+        if (System.getenv("MVNW_USERNAME") != null && System.getenv("MVNW_PASSWORD") != null) {
+            String username = System.getenv("MVNW_USERNAME");
+            char[] password = System.getenv("MVNW_PASSWORD").toCharArray();
+            Authenticator.setDefault(new Authenticator() {
+                @Override
+                protected PasswordAuthentication getPasswordAuthentication() {
+                    return new PasswordAuthentication(username, password);
+                }
+            });
+        }
+        URL website = new URL(urlString);
+        ReadableByteChannel rbc;
+        rbc = Channels.newChannel(website.openStream());
+        FileOutputStream fos = new FileOutputStream(destination);
+        fos.getChannel().transferFrom(rbc, 0, Long.MAX_VALUE);
+        fos.close();
+        rbc.close();
+    }
+
+}

BIN
gydatasync/.mvn/wrapper/maven-wrapper.jar


+ 2 - 0
gydatasync/.mvn/wrapper/maven-wrapper.properties

@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.6.3/apache-maven-3.6.3-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar

+ 78 - 0
gydatasync/log.log

@@ -0,0 +1,78 @@
+2020-07-22 14:34:40.455  INFO 7804 --- [main] c.h.gydatasync.GydatasyncApplication     : Starting GydatasyncApplication on ZJY-PC with PID 7804 (E:\Work\对外接口\桂阳\code\gydatasync\target\classes started by ZJY in E:\Work\对外接口\桂阳\code\gydatasync)
+2020-07-22 14:34:40.490  INFO 7804 --- [main] c.h.gydatasync.GydatasyncApplication     : The following profiles are active: dev
+2020-07-22 14:34:42.879  INFO 7804 --- [main] o.s.s.c.ThreadPoolTaskScheduler          : Initializing ExecutorService 'taskScheduler'
+2020-07-22 14:35:06.987  INFO 7804 --- [main] c.h.gydatasync.GydatasyncApplication     : Started GydatasyncApplication in 27.194 seconds (JVM running for 28.189)
+2020-07-22 14:35:07.048  INFO 7804 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Starting...
+2020-07-22 14:35:15.065  INFO 7804 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Start completed.
+2020-07-22 14:35:15.122 DEBUG 7804 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==>  Preparing: select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+2020-07-22 14:35:15.887 DEBUG 7804 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==> Parameters: 
+2020-07-22 14:35:16.376 DEBUG 7804 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : <==      Total: 1
+2020-07-22 14:40:09.330  WARN 7804 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=4m54s159ms653µs980ns).
+2020-07-22 14:40:09.333  INFO 7804 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Starting...
+2020-07-22 14:40:09.899  INFO 7804 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Start completed.
+2020-07-22 14:40:09.901 DEBUG 7804 --- [scheduling-1] c.h.g.dao.mysql.ReadMeterDao.getAllList  : ==>  Preparing: SELECT sd.water_meter_file_no as customerID, a.device_id as deviceID, a.read_data as cbz, a.read_time as cbsj, now() as upLoadDateTime, CONCAT(sd.water_meter_file_no,'1') as customerMeterID FROM sc_meter_read_record a left JOIN sc_device sd on a.device_id = sd.id WHERE a.read_date = DATE_FORMAT( DATE_SUB( now(), INTERVAL 1 DAY ), '%Y%m%d' ) AND a.device_id IN ( SELECT id FROM sc_device WHERE building_id IN ( 6675, 6676, 6677, 6678, 6679, 6680 ) AND STATUS = 1 )
+2020-07-22 14:40:09.938 DEBUG 7804 --- [scheduling-1] c.h.g.dao.mysql.ReadMeterDao.getAllList  : ==> Parameters: 
+2020-07-22 14:40:10.479 DEBUG 7804 --- [scheduling-1] c.h.g.dao.mysql.ReadMeterDao.getAllList  : <==      Total: 476
+2020-07-22 14:40:56.786  WARN 7804 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=47s455ms360µs350ns).
+2020-07-22 14:40:56.788  WARN 7804 --- [HikariPool-2 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-2 - Thread starvation or clock leap detected (housekeeper delta=46s787ms862µs479ns).
+2020-07-22 14:40:56.856  INFO 7804 --- [SpringContextShutdownHook] o.s.s.c.ThreadPoolTaskScheduler          : Shutting down ExecutorService 'taskScheduler'
+2020-07-22 14:40:56.857  INFO 7804 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown initiated...
+2020-07-22 14:40:56.862  INFO 7804 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown completed.
+2020-07-22 14:40:56.864  INFO 7804 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Shutdown initiated...
+2020-07-22 14:40:56.872  INFO 7804 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Shutdown completed.
+2020-07-22 14:45:16.734  INFO 10816 --- [main] c.h.gydatasync.GydatasyncApplication     : Starting GydatasyncApplication on ZJY-PC with PID 10816 (E:\Work\对外接口\桂阳\code\gydatasync\target\classes started by ZJY in E:\Work\对外接口\桂阳\code\gydatasync)
+2020-07-22 14:45:16.739  INFO 10816 --- [main] c.h.gydatasync.GydatasyncApplication     : The following profiles are active: dev
+2020-07-22 14:45:17.751  INFO 10816 --- [main] o.s.s.c.ThreadPoolTaskScheduler          : Initializing ExecutorService 'taskScheduler'
+2020-07-22 14:45:22.081  INFO 10816 --- [main] c.h.gydatasync.GydatasyncApplication     : Started GydatasyncApplication in 5.737 seconds (JVM running for 6.374)
+2020-07-22 14:45:22.132  INFO 10816 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Starting...
+2020-07-22 14:45:29.890  INFO 10816 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Start completed.
+2020-07-22 14:45:29.946 DEBUG 10816 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==>  Preparing: select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+2020-07-22 14:45:30.688 DEBUG 10816 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==> Parameters: 
+2020-07-22 14:45:31.089 DEBUG 10816 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : <==      Total: 1
+2020-07-22 14:46:41.936  WARN 10816 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=1m11s944ms422µs457ns).
+2020-07-22 14:46:41.937  INFO 10816 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Starting...
+2020-07-22 14:46:41.997  INFO 10816 --- [SpringContextShutdownHook] o.s.s.c.ThreadPoolTaskScheduler          : Shutting down ExecutorService 'taskScheduler'
+2020-07-22 14:46:41.999  INFO 10816 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown initiated...
+2020-07-22 14:46:42.005  INFO 10816 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown completed.
+2020-07-22 14:52:03.682  INFO 11176 --- [main] c.h.gydatasync.GydatasyncApplication     : Starting GydatasyncApplication on ZJY-PC with PID 11176 (E:\Work\对外接口\桂阳\code\gydatasync\target\classes started by ZJY in E:\Work\对外接口\桂阳\code\gydatasync)
+2020-07-22 14:52:03.684  INFO 11176 --- [main] c.h.gydatasync.GydatasyncApplication     : The following profiles are active: dev
+2020-07-22 14:52:04.720  INFO 11176 --- [main] o.s.s.c.ThreadPoolTaskScheduler          : Initializing ExecutorService 'taskScheduler'
+2020-07-22 14:52:08.049  INFO 11176 --- [main] c.h.gydatasync.GydatasyncApplication     : Started GydatasyncApplication in 4.734 seconds (JVM running for 5.359)
+2020-07-22 14:52:08.100  INFO 11176 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Starting...
+2020-07-22 14:52:16.759  INFO 11176 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Start completed.
+2020-07-22 14:52:16.817 DEBUG 11176 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==>  Preparing: select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+2020-07-22 14:52:17.627 DEBUG 11176 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==> Parameters: 
+2020-07-22 14:52:18.056 DEBUG 11176 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : <==      Total: 1
+2020-07-22 14:53:08.573  WARN 11176 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=51s711ms984µs857ns).
+2020-07-22 14:53:08.575  INFO 11176 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Starting...
+2020-07-22 14:53:08.624  INFO 11176 --- [SpringContextShutdownHook] o.s.s.c.ThreadPoolTaskScheduler          : Shutting down ExecutorService 'taskScheduler'
+2020-07-22 14:53:08.625  INFO 11176 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown initiated...
+2020-07-22 14:53:08.631  INFO 11176 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown completed.
+2020-07-22 14:56:00.743  INFO 9644 --- [main] c.h.gydatasync.GydatasyncApplication     : Starting GydatasyncApplication on ZJY-PC with PID 9644 (E:\Work\对外接口\桂阳\code\gydatasync\target\classes started by ZJY in E:\Work\对外接口\桂阳\code\gydatasync)
+2020-07-22 14:56:00.746  INFO 9644 --- [main] c.h.gydatasync.GydatasyncApplication     : The following profiles are active: dev
+2020-07-22 14:56:01.851  INFO 9644 --- [main] o.s.s.c.ThreadPoolTaskScheduler          : Initializing ExecutorService 'taskScheduler'
+2020-07-22 14:56:01.886  INFO 9644 --- [main] c.h.gydatasync.GydatasyncApplication     : Started GydatasyncApplication in 1.492 seconds (JVM running for 2.129)
+2020-07-22 14:56:01.898  INFO 9644 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Starting...
+2020-07-22 14:56:02.104  INFO 9644 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Start completed.
+2020-07-22 14:56:02.111 DEBUG 9644 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==>  Preparing: select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+2020-07-22 14:56:02.141 DEBUG 9644 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==> Parameters: 
+2020-07-22 14:56:02.169 DEBUG 9644 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : <==      Total: 1
+2020-07-22 15:01:41.411  INFO 9644 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Starting...
+2020-07-22 15:01:41.413  WARN 9644 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=6m9s302ms961µs737ns).
+2020-07-22 15:01:41.469  INFO 9644 --- [SpringContextShutdownHook] o.s.s.c.ThreadPoolTaskScheduler          : Shutting down ExecutorService 'taskScheduler'
+2020-07-22 15:01:41.470  INFO 9644 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown initiated...
+2020-07-22 15:01:41.482  INFO 9644 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown completed.
+2020-07-22 15:01:54.872  INFO 4348 --- [main] c.h.gydatasync.GydatasyncApplication     : Starting GydatasyncApplication on ZJY-PC with PID 4348 (E:\Work\对外接口\桂阳\code\gydatasync\target\classes started by ZJY in E:\Work\对外接口\桂阳\code\gydatasync)
+2020-07-22 15:01:54.875  INFO 4348 --- [main] c.h.gydatasync.GydatasyncApplication     : The following profiles are active: dev
+2020-07-22 15:01:55.927  INFO 4348 --- [main] o.s.s.c.ThreadPoolTaskScheduler          : Initializing ExecutorService 'taskScheduler'
+2020-07-22 15:01:55.964  INFO 4348 --- [main] c.h.gydatasync.GydatasyncApplication     : Started GydatasyncApplication in 1.484 seconds (JVM running for 2.102)
+2020-07-22 15:01:55.976  INFO 4348 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Starting...
+2020-07-22 15:01:56.176  INFO 4348 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Start completed.
+2020-07-22 15:01:56.184 DEBUG 4348 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==>  Preparing: select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+2020-07-22 15:01:56.205 DEBUG 4348 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : ==> Parameters: 
+2020-07-22 15:01:56.233 DEBUG 4348 --- [scheduling-1] c.h.g.d.mssql.SaveMeterDataDao.IsExist   : <==      Total: 1
+2020-07-22 15:02:24.323  WARN 4348 --- [HikariPool-1 housekeeper] com.zaxxer.hikari.pool.HikariPool        : HikariPool-1 - Thread starvation or clock leap detected (housekeeper delta=58s146ms293µs997ns).
+2020-07-22 15:02:24.325  INFO 4348 --- [scheduling-1] com.zaxxer.hikari.HikariDataSource       : HikariPool-2 - Starting...
+2020-07-22 15:02:24.401  INFO 4348 --- [SpringContextShutdownHook] o.s.s.c.ThreadPoolTaskScheduler          : Shutting down ExecutorService 'taskScheduler'
+2020-07-22 15:02:24.403  INFO 4348 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown initiated...
+2020-07-22 15:02:24.410  INFO 4348 --- [SpringContextShutdownHook] com.zaxxer.hikari.HikariDataSource       : HikariPool-1 - Shutdown completed.

+ 310 - 0
gydatasync/mvnw

@@ -0,0 +1,310 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#    https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+#   JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+#   M2_HOME - location of maven2's installed home dir
+#   MAVEN_OPTS - parameters passed to the Java VM when running Maven
+#     e.g. to debug Maven itself, use
+#       set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+#   MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+  if [ -f /etc/mavenrc ] ; then
+    . /etc/mavenrc
+  fi
+
+  if [ -f "$HOME/.mavenrc" ] ; then
+    . "$HOME/.mavenrc"
+  fi
+
+fi
+
+# OS specific support.  $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+  CYGWIN*) cygwin=true ;;
+  MINGW*) mingw=true;;
+  Darwin*) darwin=true
+    # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+    # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+    if [ -z "$JAVA_HOME" ]; then
+      if [ -x "/usr/libexec/java_home" ]; then
+        export JAVA_HOME="`/usr/libexec/java_home`"
+      else
+        export JAVA_HOME="/Library/Java/Home"
+      fi
+    fi
+    ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+  if [ -r /etc/gentoo-release ] ; then
+    JAVA_HOME=`java-config --jre-home`
+  fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+  ## resolve links - $0 may be a link to maven's home
+  PRG="$0"
+
+  # need this for relative symlinks
+  while [ -h "$PRG" ] ; do
+    ls=`ls -ld "$PRG"`
+    link=`expr "$ls" : '.*-> \(.*\)$'`
+    if expr "$link" : '/.*' > /dev/null; then
+      PRG="$link"
+    else
+      PRG="`dirname "$PRG"`/$link"
+    fi
+  done
+
+  saveddir=`pwd`
+
+  M2_HOME=`dirname "$PRG"`/..
+
+  # make it fully qualified
+  M2_HOME=`cd "$M2_HOME" && pwd`
+
+  cd "$saveddir"
+  # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME=`cygpath --unix "$M2_HOME"`
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+  [ -n "$CLASSPATH" ] &&
+    CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME="`(cd "$M2_HOME"; pwd)`"
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+  javaExecutable="`which javac`"
+  if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+    # readlink(1) is not available as standard on Solaris 10.
+    readLink=`which readlink`
+    if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+      if $darwin ; then
+        javaHome="`dirname \"$javaExecutable\"`"
+        javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+      else
+        javaExecutable="`readlink -f \"$javaExecutable\"`"
+      fi
+      javaHome="`dirname \"$javaExecutable\"`"
+      javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+      JAVA_HOME="$javaHome"
+      export JAVA_HOME
+    fi
+  fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+  if [ -n "$JAVA_HOME"  ] ; then
+    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+      # IBM's JDK on AIX uses strange locations for the executables
+      JAVACMD="$JAVA_HOME/jre/sh/java"
+    else
+      JAVACMD="$JAVA_HOME/bin/java"
+    fi
+  else
+    JAVACMD="`which java`"
+  fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+  echo "Error: JAVA_HOME is not defined correctly." >&2
+  echo "  We cannot execute $JAVACMD" >&2
+  exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+  echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+  if [ -z "$1" ]
+  then
+    echo "Path not specified to find_maven_basedir"
+    return 1
+  fi
+
+  basedir="$1"
+  wdir="$1"
+  while [ "$wdir" != '/' ] ; do
+    if [ -d "$wdir"/.mvn ] ; then
+      basedir=$wdir
+      break
+    fi
+    # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+    if [ -d "${wdir}" ]; then
+      wdir=`cd "$wdir/.."; pwd`
+    fi
+    # end of workaround
+  done
+  echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+  if [ -f "$1" ]; then
+    echo "$(tr -s '\n' ' ' < "$1")"
+  fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+  exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Found .mvn/wrapper/maven-wrapper.jar"
+    fi
+else
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+    fi
+    if [ -n "$MVNW_REPOURL" ]; then
+      jarUrl="$MVNW_REPOURL/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+    else
+      jarUrl="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+    fi
+    while IFS="=" read key value; do
+      case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+      esac
+    done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Downloading from: $jarUrl"
+    fi
+    wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+    if $cygwin; then
+      wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+    fi
+
+    if command -v wget > /dev/null; then
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Found wget ... using wget"
+        fi
+        if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+            wget "$jarUrl" -O "$wrapperJarPath"
+        else
+            wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath"
+        fi
+    elif command -v curl > /dev/null; then
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Found curl ... using curl"
+        fi
+        if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+            curl -o "$wrapperJarPath" "$jarUrl" -f
+        else
+            curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+        fi
+
+    else
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Falling back to using Java to download"
+        fi
+        javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+        # For Cygwin, switch paths to Windows format before running javac
+        if $cygwin; then
+          javaClass=`cygpath --path --windows "$javaClass"`
+        fi
+        if [ -e "$javaClass" ]; then
+            if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+                if [ "$MVNW_VERBOSE" = true ]; then
+                  echo " - Compiling MavenWrapperDownloader.java ..."
+                fi
+                # Compiling the Java class
+                ("$JAVA_HOME/bin/javac" "$javaClass")
+            fi
+            if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+                # Running the downloader
+                if [ "$MVNW_VERBOSE" = true ]; then
+                  echo " - Running MavenWrapperDownloader.java ..."
+                fi
+                ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+            fi
+        fi
+    fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+  echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME=`cygpath --path --windows "$M2_HOME"`
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+  [ -n "$CLASSPATH" ] &&
+    CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+  [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+    MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+  $MAVEN_OPTS \
+  -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+  "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+  ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"

+ 182 - 0
gydatasync/mvnw.cmd

@@ -0,0 +1,182 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements.  See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership.  The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License.  You may obtain a copy of the License at
+@REM
+@REM    https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied.  See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM     e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on"  echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+
+FOR /F "tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+    IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Found %WRAPPER_JAR%
+    )
+) else (
+    if not "%MVNW_REPOURL%" == "" (
+        SET DOWNLOAD_URL="%MVNW_REPOURL%/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+    )
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Couldn't find %WRAPPER_JAR%, downloading it ...
+        echo Downloading from: %DOWNLOAD_URL%
+    )
+
+    powershell -Command "&{"^
+		"$webclient = new-object System.Net.WebClient;"^
+		"if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+		"$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+		"}"^
+		"[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+		"}"
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Finished downloading %WRAPPER_JAR%
+    )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%

+ 85 - 0
gydatasync/pom.xml

@@ -0,0 +1,85 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
+    <modelVersion>4.0.0</modelVersion>
+    <parent>
+        <groupId>org.springframework.boot</groupId>
+        <artifactId>spring-boot-starter-parent</artifactId>
+        <version>2.3.1.RELEASE</version>
+        <relativePath/> <!-- lookup parent from repository -->
+    </parent>
+    <groupId>com.huaxu</groupId>
+    <artifactId>gydatasync</artifactId>
+    <version>0.0.1-SNAPSHOT</version>
+    <name>gydatasync</name>
+    <description>Demo project for Spring Boot</description>
+
+    <properties>
+        <java.version>1.8</java.version>
+    </properties>
+
+    <dependencies>
+        <dependency>
+            <groupId>org.mybatis.spring.boot</groupId>
+            <artifactId>mybatis-spring-boot-starter</artifactId>
+            <version>2.1.3</version>
+        </dependency>
+
+        <dependency>
+            <groupId>com.microsoft.sqlserver</groupId>
+            <artifactId>mssql-jdbc</artifactId>
+            <scope>runtime</scope>
+        </dependency>
+        <dependency>
+            <groupId>mysql</groupId>
+            <artifactId>mysql-connector-java</artifactId>
+            <scope>runtime</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.projectlombok</groupId>
+            <artifactId>lombok</artifactId>
+            <optional>true</optional>
+        </dependency>
+
+        <dependency>
+            <groupId>org.springframework.boot</groupId>
+            <artifactId>spring-boot-configuration-processor</artifactId>
+            <optional>true</optional>
+        </dependency>
+
+        <dependency>
+            <groupId>com.fasterxml.jackson.core</groupId>
+            <artifactId>jackson-databind</artifactId>
+        </dependency>
+
+        <dependency>
+            <groupId>org.springframework.boot</groupId>
+            <artifactId>spring-boot-starter-test</artifactId>
+            <scope>test</scope>
+            <exclusions>
+                <exclusion>
+                    <groupId>org.junit.vintage</groupId>
+                    <artifactId>junit-vintage-engine</artifactId>
+                </exclusion>
+            </exclusions>
+        </dependency>
+
+        <dependency>
+            <groupId>junit</groupId>
+            <artifactId>junit</artifactId>
+            <version>4.13</version>
+            <scope>test</scope>
+        </dependency>
+
+    </dependencies>
+
+    <build>
+        <plugins>
+            <plugin>
+                <groupId>org.springframework.boot</groupId>
+                <artifactId>spring-boot-maven-plugin</artifactId>
+            </plugin>
+        </plugins>
+    </build>
+
+</project>

+ 24 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/GydatasyncApplication.java

@@ -0,0 +1,24 @@
+package com.huaxu.gydatasync;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
+import org.springframework.scheduling.annotation.EnableScheduling;
+
+//@SpringBootApplication
+@EnableScheduling
+@SpringBootApplication(exclude = {DataSourceAutoConfiguration.class})
+public class GydatasyncApplication {
+
+    public static void main(String[] args) {
+        SpringApplication.run(GydatasyncApplication.class, args);
+    }
+
+}
+
+/*
+* 桂阳数据同步需求说明
+* 1、将物联网系统中每天抄表数据插入到中间MISEMP数据库中的WaterData表中
+* 2、需完善物联网系统中的营销户号,营销户号从客户提供的excel表格中导出,根据客户地址关联得到营销户号,营销户号保存到物联网系统数据库中的sc_device表中的water_meter_file_no字段中
+*/
+

+ 19 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/config/FirstDataBaseProperties.java

@@ -0,0 +1,19 @@
+package com.huaxu.gydatasync.config;
+
+import lombok.Data;
+import org.springframework.boot.context.properties.ConfigurationProperties;
+import org.springframework.stereotype.Component;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 10:55
+ */
+@Data
+@Component
+@ConfigurationProperties(prefix = "spring.datasource.first")
+public class FirstDataBaseProperties {
+    String url;
+    String username;
+    String password;
+    String driverClassName;
+}

+ 79 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/config/FirstDataSourceConfig.java

@@ -0,0 +1,79 @@
+package com.huaxu.gydatasync.config;
+
+import org.apache.ibatis.session.SqlSessionFactory;
+import org.mybatis.spring.SqlSessionFactoryBean;
+import org.mybatis.spring.SqlSessionTemplate;
+import org.mybatis.spring.annotation.MapperScan;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.beans.factory.annotation.Qualifier;
+import org.springframework.boot.jdbc.DataSourceBuilder;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.context.annotation.Primary;
+import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
+import org.springframework.jdbc.datasource.DataSourceTransactionManager;
+
+import javax.sql.DataSource;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 10:57
+ */
+//注意:当存在多个数据源时,必须有一个数据源要加上@Primary注解
+@Configuration
+//注意:指定mapper接口位置和sqlsession实例
+@MapperScan(basePackages = "com.huaxu.gydatasync.dao.mysql",sqlSessionTemplateRef = "firstSqlSessionTemplate")
+public class FirstDataSourceConfig {
+
+    @Autowired
+    private FirstDataBaseProperties prop;
+
+    //    创建数据源
+    @Bean(name = "firstDS")
+    @Primary
+    public DataSource getFirstDataSource() {
+        DataSource build =  DataSourceBuilder.create()
+                .driverClassName(prop.driverClassName)
+                .url(prop.url)
+                .username(prop.username)
+                .password(prop.password)
+                .build();
+        return build;
+    }
+
+
+    // 创建SessionFactory
+    @Bean(name = "firstSqlSessionFactory")
+    @Primary
+    public SqlSessionFactory firstSqlSessionFactory(@Qualifier("firstDS") DataSource dataSource) throws Exception {
+        SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
+        bean.setDataSource(dataSource);
+        //注意:使用xml映射文件时必须指定xml文件路径,否则不会识别xml
+        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mappers/mysql/*.xml"));
+        return bean.getObject();
+    }
+
+    // 创建事务管理器
+    @Bean("firstTransactionManger")
+    @Primary
+    public DataSourceTransactionManager firstTransactionManger(@Qualifier("firstDS") DataSource dataSource){
+        return new DataSourceTransactionManager(dataSource);
+    }
+
+    // 创建SqlSessionTemplate
+    @Bean(name = "firstSqlSessionTemplate")
+    @Primary
+    public SqlSessionTemplate firstSqlSessionTemplate(@Qualifier("firstSqlSessionFactory") SqlSessionFactory sqlSessionFactory){
+        return new SqlSessionTemplate(sqlSessionFactory);
+    }
+
+
+    private Class getType(String type) {
+        try {
+            return Class.forName(type);
+        } catch (ClassNotFoundException e) {
+            e.printStackTrace();
+        }
+        return null;
+    }
+}

+ 19 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/config/SecondDataBaseProperties.java

@@ -0,0 +1,19 @@
+package com.huaxu.gydatasync.config;
+
+import lombok.Data;
+import org.springframework.boot.context.properties.ConfigurationProperties;
+import org.springframework.stereotype.Component;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 11:16
+ */
+@Data
+@Component
+@ConfigurationProperties(prefix = "spring.datasource.second")
+public class SecondDataBaseProperties {
+    String url;
+    String username;
+    String password;
+    String driverClassName;
+}

+ 73 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/config/SecondDataSourceConfig.java

@@ -0,0 +1,73 @@
+package com.huaxu.gydatasync.config;
+
+import org.apache.ibatis.session.SqlSessionFactory;
+import org.mybatis.spring.SqlSessionFactoryBean;
+import org.mybatis.spring.SqlSessionTemplate;
+import org.mybatis.spring.annotation.MapperScan;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.beans.factory.annotation.Qualifier;
+import org.springframework.boot.jdbc.DataSourceBuilder;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
+import org.springframework.jdbc.datasource.DataSourceTransactionManager;
+
+import javax.sql.DataSource;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 11:16
+ */
+@Configuration
+@MapperScan(basePackages = "com.huaxu.gydatasync.dao.mssql",sqlSessionTemplateRef = "secondSqlSessionTemplate")
+public class SecondDataSourceConfig {
+    @Autowired
+    SecondDataBaseProperties prop;
+
+    //    创建数据源
+    @Bean(name = "secondDS")
+    public DataSource getSecondDataSource() {
+        DataSource build =  DataSourceBuilder.create()
+                .driverClassName(prop.driverClassName)
+                .url(prop.url)
+                .username(prop.username)
+                .password(prop.password)
+                .build();
+        return build;
+    }
+
+
+    // 创建SessionFactory
+    @Bean(name = "secondSqlSessionFactory")
+    public SqlSessionFactory secondSqlSessionFactory(@Qualifier("secondDS") DataSource dataSource) throws Exception {
+        SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
+        bean.setDataSource(dataSource);
+        //注意:使用xml映射文件时必须指定xml文件路径,否则不会识别xml
+        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mappers/mssql/*.xml"));
+        return bean.getObject();
+    }
+
+
+    // 创建事务管理器
+
+    @Bean("secondTransactionManger")
+    public DataSourceTransactionManager secondTransactionManger(@Qualifier("secondDS") DataSource dataSource){
+        return new DataSourceTransactionManager(dataSource);
+    }
+
+    // 创建SqlSessionTemplate
+
+    @Bean(name = "secondSqlSessionTemplate")
+    public SqlSessionTemplate secondSqlSessionTemplate(@Qualifier("secondSqlSessionFactory") SqlSessionFactory sqlSessionFactory){
+        return new SqlSessionTemplate(sqlSessionFactory);
+    }
+
+    private Class getType(String type) {
+        try {
+            return Class.forName(type);
+        } catch (ClassNotFoundException e) {
+            e.printStackTrace();
+        }
+        return null;
+    }
+}

+ 22 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/dao/mssql/SaveMeterDataDao.java

@@ -0,0 +1,22 @@
+package com.huaxu.gydatasync.dao.mssql;
+
+import com.huaxu.gydatasync.entity.MeterReadData;
+import org.apache.ibatis.annotations.Mapper;
+import org.apache.ibatis.annotations.Param;
+import org.springframework.stereotype.Repository;
+
+import java.util.List;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 15:58
+ */
+@Mapper
+@Repository
+public interface SaveMeterDataDao {
+    int SaveData(@Param("meterReadDataList") List<MeterReadData> meterReadDataList);
+    int SaveData1(@Param("meterReadDataList") List<MeterReadData> meterReadDataList);
+
+    //当天数据是否已存在,防止数据重复
+    int IsExist();
+}

+ 17 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/dao/mysql/ReadMeterDao.java

@@ -0,0 +1,17 @@
+package com.huaxu.gydatasync.dao.mysql;
+
+import com.huaxu.gydatasync.entity.MeterReadData;
+import org.apache.ibatis.annotations.Mapper;
+import org.springframework.stereotype.Repository;
+
+import java.util.List;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 15:44
+ */
+@Mapper
+@Repository
+public interface ReadMeterDao {
+    List<MeterReadData>getAllList();
+}

+ 40 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/entity/MeterReadData.java

@@ -0,0 +1,40 @@
+package com.huaxu.gydatasync.entity;
+
+import com.fasterxml.jackson.annotation.JsonFormat;
+import lombok.Data;
+import lombok.experimental.Accessors;
+
+import java.math.BigDecimal;
+import java.time.LocalDateTime;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 15:25
+ */
+
+@Data
+@Accessors(chain = true)
+public class MeterReadData {
+    private String deviceID;
+    private String customerID;  //营销户号
+    private BigDecimal cbz;     //本次抄表
+    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
+    private LocalDateTime cbsj;//抄表时间
+    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
+    private LocalDateTime upLoadDateTime;//数据上传时间
+    private String customerMeterID; //营销户号后面+1
+}
+
+
+
+
+
+
+
+
+
+
+
+
+
+

+ 68 - 0
gydatasync/src/main/java/com/huaxu/gydatasync/service/ReadMeter.java

@@ -0,0 +1,68 @@
+package com.huaxu.gydatasync.service;
+
+import com.huaxu.gydatasync.dao.mssql.SaveMeterDataDao;
+import com.huaxu.gydatasync.dao.mysql.ReadMeterDao;
+import com.huaxu.gydatasync.entity.MeterReadData;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.scheduling.annotation.Scheduled;
+import org.springframework.stereotype.Component;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+
+/**
+ * @Author: ZJY
+ * @DATE: 2020-07-17 15:42
+ */
+@Component
+public class ReadMeter {
+
+    @Autowired
+    private ReadMeterDao readMeterDao;
+
+    @Autowired
+    private SaveMeterDataDao saveMeterDataDao;
+
+    //间隔24小时 程序启动多次会插入多次,存在重复插入数据的可能,需判断数据已存在
+    @Scheduled(fixedRate = 1000*60*60*24)
+    public void configureTasks(){
+        try {
+
+            int isExist = saveMeterDataDao.IsExist();
+            if(isExist > 0)
+            {
+
+                System.out.println("当天数据已存在!-----");
+                return;
+            }
+
+
+            //读取前一天的抄表数据
+            List<MeterReadData> meterReadDataList = readMeterDao.getAllList();
+
+            //插入到中间数据库表中
+            if(meterReadDataList != null)
+            {
+                int count = meterReadDataList.size();
+
+                int constNumber= 100; //一次插入100条记录 参数限制不能同时全部插入
+                int number  = count / constNumber + (count % constNumber>0 ? 1 : 0);
+                for (int i = 0;i<number;i++)
+                {
+                    int l = i+1;
+                    int copyNumber = count - l*constNumber >0 ?constNumber:count % constNumber;
+                    List<MeterReadData> subDataList = new ArrayList<>(constNumber);
+                    subDataList.addAll(meterReadDataList.subList(i*constNumber,i*constNumber + copyNumber ));
+
+                    saveMeterDataDao.SaveData(subDataList);
+                }
+            }
+        }
+        catch (Exception ex)
+        {
+
+        }
+
+    }
+}

+ 21 - 0
gydatasync/src/main/resources/application-dev.properties

@@ -0,0 +1,21 @@
+#数据源mysql Frist
+spring.datasource.first.url=jdbc:mysql://47.112.217.10:3306/smart_city?useUnicode=true&characterEncoding=utf-8
+spring.datasource.first.username=root
+spring.datasource.first.password=100Zone@123
+spring.datasource.first.driverClassName=com.mysql.cj.jdbc.Driver
+
+spring.datasource.hikari.minimum-idle=1
+spring.datasource.hikari.maximum-pool-size=2
+
+#数据源mssql Second
+spring.datasource.second.url=jdbc:sqlserver://127.0.0.1:1433;DatabaseName=MISEMP
+spring.datasource.second.username=sa
+spring.datasource.second.password=hxyf123
+spring.datasource.second.driverClassName=com.microsoft.sqlserver.jdbc.SQLServerDriver
+
+logging.level.com.huaxu.gydatasync.dao.*=debug
+mybatis.configuration.log-impl=org.apache.ibatis.logging.stdout.StdOutImpl
+
+//日志
+logging.level.root=info
+logging.file.name=log.log

+ 11 - 0
gydatasync/src/main/resources/application-prd.properties

@@ -0,0 +1,11 @@
+#数据源mysql Frist
+spring.datasource.first.url=jdbc:mysql://47.112.217.10:3306/smart_city?useUnicode=true&characterEncoding=utf-8
+spring.datasource.first.username=root
+spring.datasource.first.password=100Zone@123
+spring.datasource.first.driverClassName=com.mysql.cj.jdbc.Driver
+
+#数据源mssql Second
+spring.datasource.second.url=jdbc:sqlserver://116.62.17.150:1433;DatabaseName=MISEMP
+spring.datasource.second.username=sa
+spring.datasource.second.password=Harry123
+spring.datasource.second.driverClassName=com.microsoft.sqlserver.jdbc.SQLServerDriver

+ 4 - 0
gydatasync/src/main/resources/application.properties

@@ -0,0 +1,4 @@
+#开发环境:dev  测试环境:sit  线上环境:prd  演示环境:uat
+spring.profiles.active=dev
+
+

+ 48 - 0
gydatasync/src/main/resources/mappers/mssql/SaveMeterDataMapper.xml

@@ -0,0 +1,48 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
+<mapper namespace="com.huaxu.gydatasync.dao.mssql.SaveMeterDataDao">
+    <insert id="SaveData" parameterType="list" useGeneratedKeys="false">
+        insert into WaterData(
+        CustomerID,
+        CBZ,
+        CBSJ,
+        UpLoadDateTime,
+        CustomerMeterID
+        )
+        values
+        <foreach collection="meterReadDataList" item="item" separator=",">
+            (
+            #{item.customerID,jdbcType=VARCHAR},
+            #{item.cbz,jdbcType=DECIMAL},
+            #{item.cbsj,jdbcType=TIMESTAMP},
+            #{item.upLoadDateTime,jdbcType=TIMESTAMP},
+            #{item.customerMeterID,jdbcType=VARCHAR}
+            )
+        </foreach>
+    </insert>
+
+    <insert id="SaveData1" parameterType="list" useGeneratedKeys="false">
+        insert into WaterData(
+        CustomerID,
+        CBZ,
+        CBSJ,
+        UpLoadDateTime,
+        CustomerMeterID
+        )
+        SELECT V.* FROM (VALUES
+        <foreach collection="meterReadDataList" item="item" separator=",">
+            (
+            #{item.customerID},
+            #{item.cbz},
+            #{item.cbsj},
+            #{item.upLoadDateTime},
+            #{item.customerMeterID}
+            )
+        </foreach>
+        ) AS V(customerID,cbz,cbsj,upLoadDateTime,customerMeterID)
+    </insert>
+
+    <select id="IsExist" resultType="integer">
+        select COUNT(*) from WaterData where CONVERT(varchar(10),UpLoadDateTime,120) = CONVERT(varchar(10),GETDATE(),120)
+    </select>
+</mapper>

+ 20 - 0
gydatasync/src/main/resources/mappers/mysql/ReadMeterMapper.xml

@@ -0,0 +1,20 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
+<mapper namespace="com.huaxu.gydatasync.dao.mysql.ReadMeterDao">
+    <select id="getAllList" resultType="com.huaxu.gydatasync.entity.MeterReadData">
+    SELECT
+        sd.water_meter_file_no as customerID,
+        a.device_id as deviceID,
+        a.read_data as cbz,
+        a.read_time as cbsj,
+        now() as upLoadDateTime,
+        CONCAT(sd.water_meter_file_no,'1') as customerMeterID
+
+    FROM
+        sc_meter_read_record a
+        left JOIN sc_device sd on a.device_id = sd.id
+    WHERE
+        a.read_date = DATE_FORMAT( DATE_SUB( now(), INTERVAL 1 DAY ), '%Y%m%d' )
+        AND a.device_id IN ( SELECT id FROM sc_device WHERE building_id IN ( 6675, 6676, 6677, 6678, 6679, 6680 ) AND STATUS = 1 )
+    </select>
+</mapper>

+ 23 - 0
gydatasync/src/test/java/com/huaxu/gydatasync/GydatasyncApplicationTests.java

@@ -0,0 +1,23 @@
+package com.huaxu.gydatasync;
+
+
+import org.junit.jupiter.api.Test;
+import org.junit.runner.RunWith;
+
+import org.springframework.boot.test.context.SpringBootTest;
+import org.springframework.test.context.junit4.SpringRunner;
+
+import java.util.List;
+
+@RunWith(SpringRunner.class)
+@SpringBootTest
+class GydatasyncApplicationTests {
+
+
+
+    @Test
+    public void getAll() {
+
+    }
+
+}